#!/usr/bin/ruby

require 'xml'

#class Array; def sum; inject( 0 ) { |sum,x| sum+x }; end; end


def calc(node)
    res = Float(node.child.content) rescue 0 if (node.child and node.child.text?())
    return res if (res)
    node.each_attr do |attr|
	res = Float(attr.child.content) rescue 0
	return res if (res)
    end
    return 0
end

def siblings(node)
    res = 0

    i=0;
    node.children.each { |cur_node|
	break if (i+=1)>3
    }
    
    cond = if (i>3); 1 else; nil end
	
    node.children.each { |cur_node|
	if cur_node.element?
	    if cond
		res += calc(cur_node)
	    end
	    res += siblings(cur_node)
	end
    }
    
    return res
end

def parse(xml, walk)
    parser = XML::Parser.file(xml)
    doc = parser.parse
#    print doc    
    if (walk)
#	This is slowest 330 ms
#	sum = siblings(doc.root)
	
	sum = 0
#	doc.find("//*[(@* or text()) and (count(../child::*)>3)]").each do |node|

	doc.find("//*[(number(@*) or number(text())) and (count(../child::*)>3)]").each do |node|
#	    190 ms
#	    sum += calc(node)
	    
	    #Fastest approach ~ 177ms

	    res = Float(node.child.content) rescue 0 if (node.child and node.child.text?())
	    if (res)
		sum += res
	    else
		node.each_attr do |attr|
		    res = Float(attr.child.content) rescue 0
		    if (res)
			sum += res
			break
		    end
		end
	    end
	end

=begin
	sum = doc.find("//*[(number(@*) or number(text())) and (count(../child::*)>3)]").map { |node|
	    res = Float(node.child.content) rescue nil if (node.child and node.child.text?())
	    next res if ((res)&&(res!=0))
	    
	    node.each_attr do |attr|
		res = Float(attr.child.content) rescue nil
		break res if ((res)&&(res!=0))
	    end
	}.sum
=end

=begin
	sum = doc.find("//*[(number(@*) or number(text())) and (count(../child::*)>3)]").inject(0) { |sum, node|
	    res = Float(node.child.content) rescue nil if (node.child and node.child.text?())
	    next sum+res if ((res)&&(res!=0))
	    
	    node.each_attr do |attr|
		res = Float(attr.child.content) rescue nil
		break res if ((res)&&(res!=0))
	    end + sum
	}
=end

#	print "Sum: #{sum}\n"
    end
end

walk_tree = ENV['walk_tree']

if ($*.length > 0)
    iterations = $*[0].to_i
else
    iterations = 0
end

if ($*.length > 1)
    filename = lambda { |i| $*[1] }
else
    filename = lambda { |i| "../xml.tmp/#{i}.xml" }
end

parse(filename.call(0), walk_tree)

iterations.times { |i|
    parse(filename.call(i+1), walk_tree)
}
