#include <stdio.h>
#include <sys/time.h>

#include <vtdGen.h>
#include <vtdNav.h>
#include <autoPilot.h>


#define PREPARE_XML
#include "tools.h"


inline double walker_process_node(VTDNav *vn, AutoPilot *ap, char *xml) {
    int i;
    double res;
    char *value;
    
    i = getText(vn);
//    printf("%i %i %i\n", getCurrentIndex(vn), i, getAttrCount(vn));
    if (i >= 0) {
	res = parseDouble(vn, i);
	if ((res)&&(!isnan(res))) {
	    return res;
	}
    }

    int idx;
    int e_idx = getCurrentIndex(vn);
    int attrs = getAttrCount(vn);
    size_t offset,len;

    for (i=0,idx=e_idx+1; i<attrs;i++) {
	while (getTokenType(vn,idx) !=2) idx++;	// skipping to attribute

	if (getTokenType(vn,idx+1)==4) {	// if attribute value 
	    idx++;
	    len = getTokenLength(vn, idx);
	    offset = getTokenOffset(vn, idx);
	    res = parseDouble(vn, idx);
	    if ((res)&&(!isnan(res))) {
//	        fwrite((char *)(xml+offset),sizeof(UByte),len,stdout);
//		printf("\n");
		return res;
	    }
	}
    }
/*    
    size_t l,offset,len;
    if (selectXPath(ap,L"./@*")) {
	while (evalXPath(ap)) {
	    if (getCurrentIndex(vn)==e_idx) return 0;
	    idx = getCurrentIndex(vn);
	    len = getTokenLength(vn, idx+1);
	    offset = getTokenOffset(vn, idx+1);
	    fwrite((char *)(xml+offset),sizeof(UByte),len,stdout);
	    
	    printf(" - %i %i\n", getCurrentIndex(vn), getTokenType(vn,  getCurrentIndex(vn)+1));
	}
    }
    */
    
    return 0;
}

double walker(VTDNav *vn, AutoPilot *ap, char *xml) {
    int i = 0;
    double res = 0;
    Boolean ok;

    push(vn);
    for (ok = 1; ok; ok = toElement(vn, NEXT_SIBLING)) {
	if (++i>3) break;
    }
    pop(vn);
    
    if (i<=3) i = 0;

    for (ok = 1; ok; ok = toElement(vn, NEXT_SIBLING)) {
	if (i) {
	    res += walker_process_node(vn,ap,xml);
	}

	push(vn);
	if (toElement(vn, FIRST_CHILD)) {
	    res+=walker(vn,ap,xml);
	}
	pop(vn);
    }
    return res;
}



struct exception_context the_exception_context[1];

int pre_mode = 0;
VTDGen *vg = NULL;
char *idxbuf;
int idxlen;

void initXML(struct TestData *td) {
//    if (getenv("allow_deferring")) deferring_mode = 1;
    if (getenv("allow_preprocessing")) pre_mode = 1;

    vg = createVTDGen();
}

void releaseXML(struct TestData *td) {
    freeVTDGen(vg);
}

void preparseXML(struct TestData *td, unsigned long iter) {
    FILE *f;
    if (pre_mode) {
	setDoc(vg,td->xml,td->xmllen);
	parse(vg,1);
	
	f = fopen("/tmp/vtdxml.test", "w");
	if (!f) {
	    printf("Can't write temporary file\n");
	    exit(1);
	}
	writeIndex(vg, f);
	fclose(f);
	idxbuf = ReadFile("/tmp/vtdxml.test");
	clear(vg);
    }
}

void postparseXML(struct TestData *td, unsigned long iter) {
    if (pre_mode) {
	free(idxbuf);
    }
}


void parseXML(struct TestData *td, unsigned long iter) {
    VTDNav *vn;

    if (pre_mode) {
	vn = loadIndex2(vg, idxbuf + sizeof(unsigned long), (*(unsigned long*)idxbuf));
    } else {
	// This destructs original string
	setDoc(vg,td->xml,td->xmllen);
	parse(vg,1);
	vn = getNav(vg);
    }
    
    if (walk_tree) {
	AutoPilot *ap = NULL;//createAutoPilot2();
	double res;
//	bind (ap, vn);
	toElement(vn, ROOT);
	toElement(vn, FIRST_CHILD);
	res = walker(vn,ap,td->xml);
//	freeAutoPilot(ap);
	printf("Sum: %lf\n", res);
    }
    
    freeVTDNav(vn);
    //clear(vg); 	// done by getNav

}


int main(int argc, char *argv[]) {
    return Test(argc,argv);
}
