#include <stdio.h>
#include <sys/time.h>
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/framework/XMLGrammarPool.hpp>
#include <xercesc/framework/MemBufInputSource.hpp>
#include <xercesc/parsers/XercesDOMParser.hpp>
#include <iostream>

#include "DOMTreeErrorReporter.hpp"
#include "tools2.h"

DOMTreeErrorReporter *errReporter = NULL;
XercesDOMParser *simple_parser = NULL;
XercesDOMParser *parser = NULL;


void initXML(struct TestData *td) {
    XMLPlatformUtils::Initialize();
    errReporter = new DOMTreeErrorReporter();
    simple_parser = new XercesDOMParser;
    simple_parser->setDoNamespaces(1);

    parser = new XercesDOMParser;

}

void initXML_Validation(struct TestData *td) {
    if (simple_parser) {
	delete simple_parser;
	simple_parser = NULL;
    }
    
//    parser->loadGrammar(td->scfn, Grammar::SchemaGrammarType, true);
    parser->cacheGrammarFromParse(true);
    parser->useCachedGrammarInParse(true);
    parser->setDoSchema(1);
    parser->setDoNamespaces(1);
    parser->setValidationScheme(XercesDOMParser::Val_Always);
    parser->setValidationSchemaFullChecking(1);
    parser->setErrorHandler(errReporter);
}

void releaseXML(struct TestData *td) {
    if (parser) {
	delete parser;
	parser = NULL;
    }

    if (simple_parser) {
	delete simple_parser;
	simple_parser = NULL;
    }
    
    if (errReporter) {
	delete errReporter;
	errReporter = NULL;
    }
    
    XMLPlatformUtils::Terminate();
}

void parseXML(struct TestData *td, unsigned long iter) {
    const char id[5]="ID1\0";
    MemBufInputSource *buffer;

//    parser = new XercesDOMParser;
    
    buffer=new MemBufInputSource((XMLByte*)td->xml,td->xmllen,(const char*)&id);
    buffer->setCopyBufToStream(false);
    simple_parser->parse(*buffer);

    delete buffer;
//    delete parser;

}

void validateXML(struct TestData *td, unsigned long iter) {
    const char id[5]="ID1\0";
    MemBufInputSource *buffer;
//    XercesDOMParser *parser;
/*
    parser = new XercesDOMParser;
    parser->setDoSchema(1);
    parser->setDoNamespaces(1);
    parser->setValidationScheme(XercesDOMParser::Val_Always);
    parser->setValidationSchemaFullChecking(1);
    parser->setErrorHandler(errReporter);
*/    
    buffer=new MemBufInputSource((XMLByte*)td->xml,td->xmllen,(const char*)&id);
    buffer->setCopyBufToStream(false);
    parser->parse(*buffer);

    delete buffer;
//    delete parser;
}


int main(int argc, char *argv[]) {
    return Test(argc,argv);
}
